//
//  BackgroundTaskViewController.m
//  CoreDataLibraryApp
//
//  Created by Duncan Groenewald on 16/02/2014.
//  Copyright (c) 2014 OSSH Pty Ltd. All rights reserved.
//

#import "BackgroundTaskViewController.h"

@interface BackgroundTaskViewController ()

@end

@implementation BackgroundTaskViewController

- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil
{
    self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil];
    if (self) {
        // Custom initialization
    }
    return self;
}

- (void)viewDidLoad
{
    [super viewDidLoad];
    // Do any additional setup after loading the view from its nib.
    [self.startLoadButton addTarget:self action:@selector(load) forControlEvents:UIControlEventTouchDown];
    [self.startDeleteButton addTarget:self action:@selector(delete) forControlEvents:UIControlEventTouchDown];
    
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(displayDetails) name:OSJobStartedNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(displayDetails) name:OSJobDoneNotification object:nil];

    [self displayDetails];
}
- (void)displayDetails {
    self.loadJobsCountTextField.text = [NSString stringWithFormat:@"%d load jobs running", [[OSCDStackManager sharedManager] loadJobCount]];
    self.deleteJobsCountTextField.text = [NSString stringWithFormat:@"%d delete jobs running", [[OSCDStackManager sharedManager] deleteJobCount]];
    // Dont allow more than two jobs
    if ([[OSCDStackManager sharedManager] loadJobCount] > 2) {
        [self.startLoadButton setEnabled:NO];
    } else {
        [self.startLoadButton setEnabled:YES];
    }
    if ([[OSCDStackManager sharedManager] deleteJobCount] > 2) {
        [self.startDeleteButton setEnabled:NO];
    } else {
        [self.startDeleteButton setEnabled:YES];
    }
}
- (void)load {
    [[OSCDStackManager sharedManager] loadDataInBackground];
    [self displayDetails];
}
- (void)delete {
    [[OSCDStackManager sharedManager] deleteDataInBackground];
    [self displayDetails];
    
}
- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}

@end
